<template>
	<div id="app" :class="{dark: isDarkMode}" v-show="!isLoading">
		<Header id="header"/>
		<router-view id="main" tag="main"/>
		<Aside id="aside"/>
	</div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator"
import Aside from "./components/Aside.vue"
import Header from "./components/Header.vue"
import { ColorScheme } from "./types"

const loading = Vue.observable({loaded: false})
self.addEventListener("loaded", () => loading.loaded = true)

@Component({
	components: {
		Aside,
		Header,
	},
	computed: {
		isLoading: () => !loading.loaded,
		isDarkMode () {
			return this.$store.getters.darkMode
		},
	},
})
export default class App extends Vue {
	// detect the user preferences from media queries
	prefersDarkMode = self.matchMedia("(prefers-color-scheme: dark)").matches

	created () {
		// get the current color scheme from cache
		const current = this.$store.state.displayOptions.colorScheme

		// if the user has not explicitly chosen we use OS settings
		if (current !== ColorScheme.Dark && current !== ColorScheme.Light) {
			if (this.prefersDarkMode) {
				this.$store.commit("setColorScheme", ColorScheme.OSDark)
			} else {
				this.$store.commit("setColorScheme", ColorScheme.OSLight)
			}
		}
	}
}
</script>

<style>
@import "assets/teutonic/teutonic.min.css";

:root {
	/* Teutonic theming */
	--main-1: hsl(65, 12%, 95%);
	--main-2: hsl(65, 12%, 90%);
	--main-3: hsl(65, 12%, 55%);
	--main-4: hsl(65, 12%, 25%);
	--main-5: hsl(65, 12%, 15%);

	--prime-1: hsl(122, 60%, 90%);
	--prime-2: hsl(122, 99%, 70%);
	--prime-3: hsl(122, 54%, 45%);
	--prime-4: hsl(122, 60%, 20%);
	--prime-5: hsl(122, 63%, 12%);

	--font-body:     Avenir, Helvetica, Arial, sans-serif;
	--font-headline: var(--font-body);
	--font-standard: var(--font-body);

	& #app {
		background: var(--main-1);

		/** dark mode: for now we just lazily invert */
		&.dark {
			filter: invert(.9) hue-rotate(180deg);
			-webkit-filter:invert(.9) hue-rotate(180deg);
		}
	}

	& a[target="_blank"] {
		/* accessibility: show when a link opens in a new tab */
		&:hover::after {
			content: "";
			width: 1.4ex;
			height: 1.4ex;
			display: inline-block;
			margin-left: 0.4ch;
			margin-bottom: -.1ex;
			background-image: url(assets/icons/external-link.svg);
		}
	}
}

:root, body {
	margin: 0;
	padding: 0;
}

body {
	/* make sure the body covers the entire screen */
	min-height: 100vh;
}

/* make sure all the buttons look the same */
button::first-letter {
	text-transform: uppercase;
}

h1, h2, h3 {
	margin-top: 0.3rem;
	margin-bottom: 1rem;
}

/* accessibility: respect user's choice for animation */
@media (prefers-reduced-motion: reduce) {
	*,
	*::before,
	*::after {
		animation-duration: .001s !important;
		transition-duration: .001s !important;
	}
}
</style>
<style scoped>
#app {
	display: grid;
	min-height: 100vh;
	grid-template-columns: 1fr 1fr 330px;
	grid-template-rows: 6vw auto;
	grid-template-areas:
		"h h h"
		"m m a";
	grid-gap: 0 1em;
	-webkit-font-smoothing: antialiased;
	-moz-osx-font-smoothing: grayscale;
	margin: 0;
	padding: 0;
}

#header {
	grid-area: h;
}

#main {
	grid-area: m;
}

#aside {
	grid-area: a;
}

#main,
#aside {
	padding: 1em;
}

/* TODO: move this to Aside.vue */
#aside {
	align-items: start;
}

#main {
	align-items: start;
	align-self: start;
}

@media (max-width: 700px) {

	#app {
		grid-gap: 0 0;
		grid-template-areas:
			"h h h"
			"m m m"
			"a a a";
	}

	#aside {
		padding-top: 1.4em;
	}

	#header {
		height: 35px;
		font-size: 30px;
	}

	#main {
		margin: 0;
	}

}
</style>
